<?php
/**
* @version		$Id: vm_plusones.php 11646 2011-05-29 19:34:56Z nordmograph $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/



defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin' );
$plugin			=& JPluginHelper::getPlugin('content', 'vm_plusones');
$lang = & JFactory::getLanguage();

$lang->load('plg_content_vm_plusones', JPATH_ADMINISTRATOR);
$pluginParams	= new JParameter( $plugin->params );

class plgContentVMplusones extends JPlugin{
  	function plgContentVMplusones( &$subject, $params ){
    	parent::__construct( $subject, $params );		
    }
	function onPrepareContent( &$article, &$params, $limitstart ) {
        global $mainframe;
		
		$user 				=& JFactory::getUser();
		$db 				=& JFactory::getDBO();
		$doc				=& JFactory::getDocument();
		$juri 				= JURI::base();
		$plugin				=& JPluginHelper::getPlugin('content', 'vm_plusones');
		
		$pluginParams		= new JParameter( $plugin->params );
		$articles 			= $pluginParams->get('articles', 1);
		$onfrontpage		= $pluginParams->get('onfrontpage', 1);
		$onuncategorized 	= $pluginParams->get('onuncategorized', 1);
		$products 			= $pluginParams->get('products', 1);

		$linkedin 			= $pluginParams->get('linkedin', 1);
		$linkedin_count		= $pluginParams->get('linkedin_count', 1);
		
		
		$plusone	 		= $pluginParams->get('plusone', 1);
		$plusone_size	 	= $pluginParams->get('plusone_size', 'medium');
		$plusone_lang	 	= $pluginParams->get('plusone_size', 'lang');
		$plusone_count	 	= $pluginParams->get('plusone_count', true);
		$plusone_callback	= $pluginParams->get('plusone_callback');
		
		$tweet 				= $pluginParams->get('tweet', 1);
		$iconstyle			= $pluginParams->get('iconstyle', 'compact');
		
		$googlebuzz 		= $pluginParams->get('googlebuzz', 1);
		
		
		$facebooklike 		= $pluginParams->get('facebooklike', 1);
		$appId				= $pluginParams->get('appid');
		$fb_lang			= $pluginParams->get('fb_lang');
		$fb_colorscheme		= $pluginParams->get('fb_colorscheme','light');
		$fb_action 			= $pluginParams->get('fb_action', 'like');
		
		$profileman 		= $pluginParams->get('profileman', 0);
		$naming 			= $pluginParams->get('naming', 'username');
		$profileitemid 		= $pluginParams->get('profileitemid',0);
		$vmpre 				= $pluginParams->get('vmpre','vm');
		$showext 			= $pluginParams->get('showext',1);
		
		$short				= $pluginParams->get('short', 1);
				

		$vmvendor 			= $pluginParams->get('vmvendor', 0);
		$unshare 			= $pluginParams->get('unshare', 0);
		
		
		$forbid 			= 0;
		$comp 				= $_GET['option'];
		$pop 				= $_GET['pop'];
		
		if($products == 1 &&  $comp == 'com_virtuemart'){
			$product_id = (int) vmRequest::getInt( 'product_id', '' );
			if($product_id < 1)	
				$forbid = 1;
		}
		if ( $comp=='com_content' && $articles==1){
			$view = $_GET['view'];
			if($view!='article') $forbid = 1;
			
			$frontpage = 0;
			$q="SELECT ordering FROM #__content_frontpage WHERE content_id='".$article->id."'";			
			$db->setQuery( $q );
			$isfrontpage = $db->loadResult();
			if($isfrontpage)
				$frontpage = 1;
			if ($frontpage && !$onfrontpage)
				$forbid=1;
			$uncategorized=0;
			$q="SELECT catid,sectionid FROM #__content WHERE id='".$article->id."'";			
			$db->setQuery( $q );
			$folder = $db->loadRow();
			$catid = $folder[0];
			$sectionid = $folder[1];
			$uncatagorized=0;
			if($catid==0 OR $sectionid==0)
				$uncategorized=1;
			if($uncategorized && !$onuncategorized)
				$forbid = 1;
		}
		if($pop ==0 && $forbid == 0 &&(($products==1 && $comp=='com_virtuemart') OR ($articles==1 && $comp=='com_content'))    ) 	{
			if($_SERVER['HTTPS'] == 'on')
				$currenturl = 'https://';
			else
				$currenturl = 'http://';
			$currenturl .= $_SERVER['SERVER_PORT'] != '80' ? $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"] : $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
			$encodedurl = urlencode($currenturl);
			if($short){	
					$shorturl = "http://tinyurl.com/api-create.php?url=".$encodedurl;
					$shorturl = file_get_contents($shorturl );
					
			}
				
			if($comp=='com_virtuemart' && $products==1){ // we get the product thumb for gbuzz and add the image metatag for facebook thumbnail
				$q="SELECT product_thumb_image FROM #__vm_product WHERE product_id='".$product_id."'";
				$db->setQuery( $q );
				$thumb = $db->loadResult();
				$doc->setMetaData ('og:image', $juri.'components/com_virtuemart/shop_image/product/'.$thumb );
			}
			
				
			$doc->addStyleSheet(JURI::base().'plugins/content/vm_plusones/css/style.css');
			if(($articles==1 && $comp=='com_content' ) OR ($products==1 && $comp=='com_virtuemart' && $product_id>0 )){
				
				if(!$unshare){
					$return ='<div class="vm_plusones">';	
			$return .='<table width="100%"><tr>';
						
					
					
					if($linkedin){
						$return .='<td>';
						$doc->addScript('http://platform.linkedin.com/in.js');
						//$doc->addScriptDeclaration("{lang: '".$plusone_lang."'}");
						$return .='<div id="vm_linkedin">
							<script type="IN/Share" data-url="'.$currenturl.'" ';
						if($linkedin_count)
							$return .=' data-counter="right" ';
						$return .='	></script>
							</td>';
					}	
					
					if($plusone){
						$doc->addScript('http://apis.google.com/js/plusone.js');
						//$doc->addScriptDeclaration("{lang: '".$plusone_lang."'}");
						$return .='<td id="vm_plusone">
							<g:plusone size="'.$plusone_size.'" count="'.$plusone_count.'" callback="'.$plusone_callback.'" ">
							</g:plusone>
							</td>';
					}
					
					
					if($tweet){
						$doc->addScript('http://platform.twitter.com/widgets.js');
						$return .='<td id="vm_tweet">
						<a href="http://twitter.com/share" class="twitter-share-button" 
						data-count="horizontal" data-counturl="'.$currenturl.'" 
						data-url="'.$currenturl.'" 
						data-lang="en"
						>
						Tweet
						</a>
						</td>';
						
						
					}
					if($googlebuzz){
						$doc->addScript('http://www.google.com/buzz/api/button.js');
						$buzzstyle = $pluginParams->get('buzzstyle', 'small-count');
						$buzzaltimage = $pluginParams->get('buzzaltimage');
						$data_imageurl='data-imageurl="'.$buzzaltimage.'"';
						if($comp == 'com_virtuemart' && $product_id>0){ // we get the product thumbnail url
							if($thumb!='')
								$data_imageurl='data-imageurl="'.$juri.'components/com_virtuemart/shop_image/product/'.$thumb.'"';

						}
						$return .='<td id="vm_googlebuzz_'.$buzzstyle.'"><a title="'.JText::_( 'POSTTOGBUZZ' ).'" class="google-buzz-button" href="http://www.google.com/buzz/post" data-button-style="'.$buzzstyle.'" '.$data_imageurl.'></a></td>';
					}
					
					
					
					
					
					
					if($facebooklike>0){
						if(!$fb_lang){
							 $lang =& JFactory::getLanguage();
							$fb_lang = str_replace('-','_',$lang->getTag());
						}

						$return .= '<td id="vm_fblike" >';
						
						if($facebooklike==1){
							$return .= '<iframe src="http://www.facebook.com/plugins/like.php?locale='.$fb_lang.'&amp;href='.$encodedurl.'&amp;layout=button_count&amp;show_faces=no&amp;width='.$fb_width.'&amp;action='.$fb_action.'&amp;font=arial&amp;colorscheme='.$fb_colorscheme.'" scrolling="no" frameborder="0" allowTransparency="true" style="border:none;overflow:hidden; width:'.$fb_width.'px; height:20px"></iframe>';
						}
						elseif($facebooklike==2){
							if($appId!=""){
								$doc->addScript('http://connect.facebook.net/'.$fb_lang.'/all.js');
								$return .= '<div id="fb-root"></div>
     								 <script>
         								FB.init({ 
           									appId:'.$appId.', cookie:true, 
            								status:true, xfbml:true 
        								 });
     								 </script>';
							}
							$return .= '<fb:like layout="button_count" action="'.$fb_action.'" colorscheme="'.$fb_colorscheme.'" send=true></fb:like>';
						}
						$return .= '</td>';
					}
					
						
					if($short){
						$return .='<td id="vm_short">
							<a target="_blank" href="'.$shorturl.'">
							<img src="'.$juri.'plugins/content/vm_plusones/img/tinyurl.png" alt="TinyUrl" width="16" height="16" title="'.$shorturl.'" class="hasTip"/>
							</a>
							</td>';
					}
					
								
					
				$return .='</tr></table>';
					$return .='</div>';
					$return .='<div style="clear:both"></div>';
				}		
				
				
				if($comp == 'com_virtuemart' && $vmvendor){

						$return .='<div id="vm_vendor">';
						$product_id = (int) vmRequest::getInt( 'product_id', '' );
						if($product_id >0){
							$lang = & JFactory::getLanguage();
							$q = "SELECT file_name,file_extension FROM #__".$vmpre."_product_files WHERE file_published='1' AND file_product_id='".$product_id."' ";
							$db->setQuery( $q );
							$formats = $db->loadObjectList();
							$i = 0;
							foreach($formats as $format){
								$i++;
								$filename = JPATH_BASE. str_replace(JPATH_BASE, '', $format->file_name );
								$filesize = @filesize($filename) / 1048000;
								if( $filesize > 0.5)
									$filesize_disp =  number_format( $filesize, 2,',','.')." MB";
								else
									$filesize_disp =  number_format( $filesize*1024, 2,',','.')." KB";
								if($i>1)
									$return .='<br />';	
								$return .='<img class="favicon hasTip" src="'.$juri.'plugins/content/vm_plusones/img/file.png" width="16" height="16" alt="'.$format->file_extension.'" title="'.JText::_('FILETYPE').': '.$format->file_extension.'" /> '.JText::_('FILETYPE').': <a href="http://'.substr($lang->getName(),0,2).'.wikipedia.org/wiki/'.$format->file_extension.'" target="_blank">'.$format->file_extension.'</a> ('.$filesize_disp.') ';
							}
							$q="SELECT product_sku FROM #__".$vmpre."_product WHERE product_id='".$product_id."' AND product_publish='Y'";
							$db->setQuery($q);
							$sku = $db->loadResult();
							$dotoc = substr_count($sku,'.');
							$exp_sku = explode('.',$sku);
							$userid = $exp_sku[0];			
							if(is_numeric($userid) && $dotoc==2){
								$q="SELECT ".$naming." FROM #__users WHERE id='".$userid."' AND block='0'";
								$db->setQuery($q);
								$namae=$db->loadResult();
								if($namae){
									if($profileman==0)
										$profileurl=JRoute::_('index.php?option=com_comprofiler&task=userProfile&user='.$userid.'&Itemid='.$profileitemid.'&tab=getcbvmvendortab');
									elseif($profileman==1)
										$profileurl=JRoute::_("index.php?option=com_community&view=profile&userid=".$userid."&Itemid=".$profileitemid).'#app-vmvendor';									
									$return .= JText::_('SUBMITTEDBY').': <img class="favicon hasTip" src="'.$juri.'plugins/content/vm_plusones/img/user.png" width="16" height="16" alt="'.$namae.'" title="'.JText::_('VENDOR').': '.ucfirst($namae).'"  /> <a href="'.$profileurl.'">'.ucfirst($namae).'</a>';
							}
						}
					}
					$return .='</div>';
				}
				
				
									
				//$return .='</div>';
				
				
            	echo $return;
			}
		}	
	}	
}
$myPlugin =& new plgContentVMplusones( JDispatcher::getInstance(),$plugin->params );